
/*
 * $Id: acconfig.h,v 1.9 1999/09/07 17:45:56 rousskov Exp $
 *
 *
 * Web Polygraph                        http://polygraph.ircache.net/
 * ------------------------------------------------------------------
 *
 *  Web Polygraph is copyrighted (C) 1999 by Alex Rousskov and the
 *  University of California, San Diego (UCSD); all rights reserved.
 *
 *  You may copy and distribute VERBATIM copies of this product. 
 *  You may modify your copy for your own use. You must NOT
 *  distribute modified copies. You must NOT publish benchmarking
 *  results based on modified versions.
 *
 *  If you publish any materials derived from or related to Web
 *  Polygraph, you must give a credit reference to the IRCache group.
 *
 *  Web Polygraph is distributed without any warranty, even implied.
 *
 *  Please see the COPYRIGHT file for full details.
 *
 */


#ifndef PG_CONFIG_H
#define PG_CONFIG_H

@TOP@

/* host type from configure */
#define CONFIG_HOST_TYPE "-unknown-"

/* negative or zero if no probing has been done or probing failed */
#define PROBED_MAXFD -1

/* negative or zero if we failed to detect it */
#define DEFAULT_FD_SETSIZE -1

/* sighandler prototype (e.g. "void SignalHandler(...)" on IRIX */
#undef SIGNAL_HANDLER_TYPE

/* Some systems use socklen_t typedef for some socket operations.
 * Socklen_t may conflict with "int" that is also used.
 */
#undef HAVE_TYPE_SOCKLEN_T

/* sockaddr structure has sa_len member */
#undef HAVE_SA_LEN

/* tm structure has tm_gmtoff member */
#undef HAVE_TM_GMTOFF

/* how time zone global variable looks like (timezone, _timezone, etc.) */
#undef HAVE_TIMEZONE

/* must explicitly declare timezone global as extern */
#undef HAVE_EXTERN_TIMEZONE



@BOTTOM@

/* various post-processing fixes and adjustments */

// increase FD_SETSIZE if needed and OS supports FD_SETSIZE redifinition
#if !defined(__linux__) && !defined(linux)
#	if PROBED_MAXFD > 0 && DEFAULT_FD_SETSIZE > 0 && PROBED_MAXFD > DEFAULT_FD_SETSIZE
#		ifdef FD_SETSIZE
#			warning FD_SETSIZE is already defined
#		else
#			define FD_SETSIZE PROBED_MAXFD
#		endif
#	endif
#endif

// define socklen_t if not defined for us
#ifndef HAVE_TYPE_SOCKLEN_T
typedef int socklen_t;
#endif

// define SignalHandler type
typedef SIGNAL_HANDLER_TYPE;

// define xtimezone to be whatever ./configure told us
#if defined(HAVE_TIMEZONE)
#	define xtimezone HAVE_TIMEZONE
#else
#	define xtimezone 0
#endif

// what file scanner (select(2), poll(2), etc) use by default
// note: our current heuristic will fail in many environments
#ifdef HAVE_POLL
#	define PG_PREFFERED_FILE_SCANNER Poll
#else
#	define PG_PREFFERED_FILE_SCANNER Select
#endif


#endif /* PG_CONFIG_H */
