
/*
 * $Id: BcastRcver.cc,v 1.4 1999/09/07 17:46:00 rousskov Exp $
 *
 *
 * Web Polygraph                        http://polygraph.ircache.net/
 * ------------------------------------------------------------------
 *
 *  Web Polygraph is copyrighted (C) 1999 by Alex Rousskov and the
 *  University of California, San Diego (UCSD); all rights reserved.
 *
 *  You may copy and distribute VERBATIM copies of this product. 
 *  You may modify your copy for your own use. You must NOT
 *  distribute modified copies. You must NOT publish benchmarking
 *  results based on modified versions.
 *
 *  If you publish any materials derived from or related to Web
 *  Polygraph, you must give a credit reference to the IRCache group.
 *
 *  Web Polygraph is distributed without any warranty, even implied.
 *
 *  Please see the COPYRIGHT file for full details.
 *
 */

#include "polygraph.h"

#include "BcastChannel.h"
#include "BcastRcver.h"

BcastRcver::~BcastRcver() {
	stopListen();
}

void BcastRcver::startListen() {
	for (int i = 0; i < theChannels.count(); ++i)
		theChannels[i]->subscribe(this);
}

void BcastRcver::stopListen() {
	for (int i = 0; i < theChannels.count(); ++i)
		theChannels[i]->unsubscribe(this);
}

void BcastRcver::noteConnEvent(BcastChannel *, const Connection *) { Assert(0); }
void BcastRcver::noteXactEvent(BcastChannel *, const Xaction *) { Assert(0); }
void BcastRcver::noteMsgStrEvent(BcastChannel *, const char *) { Assert(0); }
void BcastRcver::noteErrNoEvent(BcastChannel *, int) { Assert(0); }
