
/*
 * $Id: CltOpts.cc,v 1.11 1999/09/07 17:46:01 rousskov Exp $
 *
 *
 * Web Polygraph                        http://polygraph.ircache.net/
 * ------------------------------------------------------------------
 *
 *  Web Polygraph is copyrighted (C) 1999 by Alex Rousskov and the
 *  University of California, San Diego (UCSD); all rights reserved.
 *
 *  You may copy and distribute VERBATIM copies of this product. 
 *  You may modify your copy for your own use. You must NOT
 *  distribute modified copies. You must NOT publish benchmarking
 *  results based on modified versions.
 *
 *  If you publish any materials derived from or related to Web
 *  Polygraph, you must give a credit reference to the IRCache group.
 *
 *  Web Polygraph is distributed without any warranty, even implied.
 *
 *  Please see the COPYRIGHT file for full details.
 *
 */

#include "polygraph.h"

#include "CltOpts.h"
#include "UniqId.h"
#include "Rnd.h"
#include "SharedOpts.h"

#include "globals.h"

CltOpts TheCltOpts;


CltOpts::CltOpts():
	thePxyAddr(this,        "proxy <host:port>",  "proxy host", NetAddr()),

	thePorts(this,          "ports <port_range>", "ephemeral|range"),

	ignoreFalseHits(this,   "ign_false_hits <bool>","ignore false hits", true),
	printFalseMisses(this,  "prn_false_misses <bool>","dump rep headers of false misses")
{
	theWorld.share(this);
}

bool CltOpts::validate() const {
	return theWorld.validate() && OptGrp::validate();
}
