
/*
 * $Id: PortMgr.cc,v 1.4 1999/09/07 17:46:22 rousskov Exp $
 *
 *
 * Web Polygraph                        http://polygraph.ircache.net/
 * ------------------------------------------------------------------
 *
 *  Web Polygraph is copyrighted (C) 1999 by Alex Rousskov and the
 *  University of California, San Diego (UCSD); all rights reserved.
 *
 *  You may copy and distribute VERBATIM copies of this product. 
 *  You may modify your copy for your own use. You must NOT
 *  distribute modified copies. You must NOT publish benchmarking
 *  results based on modified versions.
 *
 *  If you publish any materials derived from or related to Web
 *  Polygraph, you must give a credit reference to the IRCache group.
 *
 *  Web Polygraph is distributed without any warranty, even implied.
 *
 *  Please see the COPYRIGHT file for full details.
 *
 */

#include "polygraph.h"

#include "Socket.h"
#include "PortMgr.h"
#include "ErrorMgr.h"


PortMgr::PortMgr() {
	theResPorts.resize(64*1024); // hardcoded limit
}

int PortMgr::bind(Socket &s) {
	const int port = allocPort(s);
	if (port >= 0) // success
		++theBoundLvl;
	else
		ReportError(errno);
	return port;
}

void PortMgr::release(int port, bool good) {
	Assert(port >= 0);
	freePort(port, good);
	--theBoundLvl;
}
