
/*
 * $Id: ZipfPopMdl.cc,v 1.5 1999/09/07 17:46:35 rousskov Exp $
 *
 *
 * Web Polygraph                        http://polygraph.ircache.net/
 * ------------------------------------------------------------------
 *
 *  Web Polygraph is copyrighted (C) 1999 by Alex Rousskov and the
 *  University of California, San Diego (UCSD); all rights reserved.
 *
 *  You may copy and distribute VERBATIM copies of this product. 
 *  You may modify your copy for your own use. You must NOT
 *  distribute modified copies. You must NOT publish benchmarking
 *  results based on modified versions.
 *
 *  If you publish any materials derived from or related to Web
 *  Polygraph, you must give a credit reference to the IRCache group.
 *
 *  Web Polygraph is distributed without any warranty, even implied.
 *
 *  Please see the COPYRIGHT file for full details.
 *
 */

#include "polygraph.h"

#include "Rnd.h"
#include "Oid.h"
#include "TmlModel.h"
#include "ZipfPopMdl.h"
#include "rndDistrs.h"

ZipfPopMdl::ZipfPopMdl(): theDistr(0) {
	theDistr = new ZipfDistr(new RndGen, 0); // world size is unknown
}

ZipfPopMdl::~ZipfPopMdl() {
	delete theDistr;
}

int ZipfPopMdl::repeatId(int lastId) {
	// old id, zipf distributed
	return theDistr->ltrial(1, lastId);
}

ostream &ZipfPopMdl::print(ostream &os) const {
	return os << "zipf()";
}
