
/*
 * $Id: Agent.h,v 1.2 1999/09/07 17:46:45 rousskov Exp $
 *
 *
 * Web Polygraph                        http://polygraph.ircache.net/
 * ------------------------------------------------------------------
 *
 *  Web Polygraph is copyrighted (C) 1999 by Alex Rousskov and the
 *  University of California, San Diego (UCSD); all rights reserved.
 *
 *  You may copy and distribute VERBATIM copies of this product. 
 *  You may modify your copy for your own use. You must NOT
 *  distribute modified copies. You must NOT publish benchmarking
 *  results based on modified versions.
 *
 *  If you publish any materials derived from or related to Web
 *  Polygraph, you must give a credit reference to the IRCache group.
 *
 *  Web Polygraph is distributed without any warranty, even implied.
 *
 *  Please see the COPYRIGHT file for full details.
 *
 */

#ifndef PG_AGENT_CLASS_H
#define PG_AGENT_CLASS_H

#include "String.h"
#include "NetAddr.h"

class SockOpt;
class AgentSym;
class RndDistr;

// common stuff for servers and clients
class Agent {
	public:
		Agent();
		virtual ~Agent();

		virtual void start() = 0;

	protected:
		void configure(const AgentSym *cfg, SockOpt &opt);

	protected:
		String theKind;          // user specified label
		NetAddr theHost;         // the [host:]port we live on
		RndDistr *theThinkDistr; // think time for sactions
};

#endif
