
/*
 * $Id: Client.h,v 1.18 1999/09/07 17:46:48 rousskov Exp $
 *
 *
 * Web Polygraph                        http://polygraph.ircache.net/
 * ------------------------------------------------------------------
 *
 *  Web Polygraph is copyrighted (C) 1999 by Alex Rousskov and the
 *  University of California, San Diego (UCSD); all rights reserved.
 *
 *  You may copy and distribute VERBATIM copies of this product. 
 *  You may modify your copy for your own use. You must NOT
 *  distribute modified copies. You must NOT publish benchmarking
 *  results based on modified versions.
 *
 *  If you publish any materials derived from or related to Web
 *  Polygraph, you must give a credit reference to the IRCache group.
 *
 *  Web Polygraph is distributed without any warranty, even implied.
 *
 *  Please see the COPYRIGHT file for full details.
 *
 */

#ifndef PG_CLIENT_CLASS_H
#define PG_CLIENT_CLASS_H

#include "AlarmClock.h"
#include "Farm.h"
#include "Agent.h"
#include "CltXact.h"

class CltConnMgr;
class SockOpt;
class Connection;
class RndDistr;
class RobotSym;

class Client: public Agent, public AlarmUser {
	public:
		Client();
		virtual ~Client();

		virtual void configure(const RobotSym *cfg);
		virtual void start();

		virtual void noteXactDone(CltXact *x);

	protected:
		void configureConnMgrs(const RobotSym *cfg, const SockOpt &opt);
		void scheduleLaunch(Time lastLaunch);
		void launch();

	protected:
		static ObjFarm<CltXact> TheXacts;
		Array<CltConnMgr*> theConnMgrs;
		RndDistr *theOriginDistr;

		Time theLaunchWin;
		int theLaunchCount; // number of xaction launches
};

#endif
