
/*
 * $Id: CltXact.h,v 1.5 1999/09/07 17:46:49 rousskov Exp $
 *
 *
 * Web Polygraph                        http://polygraph.ircache.net/
 * ------------------------------------------------------------------
 *
 *  Web Polygraph is copyrighted (C) 1999 by Alex Rousskov and the
 *  University of California, San Diego (UCSD); all rights reserved.
 *
 *  You may copy and distribute VERBATIM copies of this product. 
 *  You may modify your copy for your own use. You must NOT
 *  distribute modified copies. You must NOT publish benchmarking
 *  results based on modified versions.
 *
 *  If you publish any materials derived from or related to Web
 *  Polygraph, you must give a credit reference to the IRCache group.
 *
 *  Web Polygraph is distributed without any warranty, even implied.
 *
 *  Please see the COPYRIGHT file for full details.
 *
 */

#ifndef CLT_XACTION_H
#define CLT_XACTION_H

#include "httpHdrs.h"
#include "Xaction.h"

class Client;
class WrBuf;

class CltXact: public Xaction {
	public:
		CltXact() { reset(); }

		void reset();

		void exec(Client *anOwner, Connection *aConn);

		virtual void noteReadReady(int fd);
		virtual void noteWriteReady(int fd);

	protected:
		int interpretHeader();
		void makeReq(WrBuf &buf);
		void finish(int errNo);

	protected:
		Client *theOwner;
		RepHdr theRepHdr;
		Size theConsumedSize;
};

#endif
