
/*
 * $Id: HitModel.h,v 1.3 1999/09/07 17:46:59 rousskov Exp $
 *
 *
 * Web Polygraph                        http://polygraph.ircache.net/
 * ------------------------------------------------------------------
 *
 *  Web Polygraph is copyrighted (C) 1999 by Alex Rousskov and the
 *  University of California, San Diego (UCSD); all rights reserved.
 *
 *  You may copy and distribute VERBATIM copies of this product. 
 *  You may modify your copy for your own use. You must NOT
 *  distribute modified copies. You must NOT publish benchmarking
 *  results based on modified versions.
 *
 *  If you publish any materials derived from or related to Web
 *  Polygraph, you must give a credit reference to the IRCache group.
 *
 *  Web Polygraph is distributed without any warranty, even implied.
 *
 *  Please see the COPYRIGHT file for full details.
 *
 */

#ifndef HIT_MODEL_H
#define HIT_MODEL_H

#include "Rnd.h"

// makes hit-or-miss decisions
// the model is very simple for now
class HitModel {
	public:
		HitModel(): theHR(0) {}

		void hr(double aHR) { theHR = aHR; }
		double hr() const { return theHR; }

		bool hitIt() { return theGen() < theHR; }

	protected:
		RndGen theGen;
		double theHR;
};

#endif
