
/*
 * $Id: LogObj.h,v 1.2 1999/09/07 17:47:05 rousskov Exp $
 *
 *
 * Web Polygraph                        http://polygraph.ircache.net/
 * ------------------------------------------------------------------
 *
 *  Web Polygraph is copyrighted (C) 1999 by Alex Rousskov and the
 *  University of California, San Diego (UCSD); all rights reserved.
 *
 *  You may copy and distribute VERBATIM copies of this product. 
 *  You may modify your copy for your own use. You must NOT
 *  distribute modified copies. You must NOT publish benchmarking
 *  results based on modified versions.
 *
 *  If you publish any materials derived from or related to Web
 *  Polygraph, you must give a credit reference to the IRCache group.
 *
 *  Web Polygraph is distributed without any warranty, even implied.
 *
 *  Please see the COPYRIGHT file for full details.
 *
 */

#ifndef PG_LOG_OBJECT_CLASS_H
#define PG_LOG_OBJECT_CLASS_H

// an optional parent of logged objects

class OLog;
class ILog;

struct LogObj {
	virtual ~LogObj() {}
	virtual OLog &store(OLog &ol) const = 0;
	virtual ILog &load(ILog &il) = 0;
};

inline OLog &operator <<(OLog &log, const LogObj &o) { o.store(log); return log; }
inline ILog &operator >>(ILog &log, LogObj &o) { o.load(log); return log; }


#endif
