
/*
 * $Id: PolyOLog.h,v 1.2 1999/09/07 17:47:13 rousskov Exp $
 *
 *
 * Web Polygraph                        http://polygraph.ircache.net/
 * ------------------------------------------------------------------
 *
 *  Web Polygraph is copyrighted (C) 1999 by Alex Rousskov and the
 *  University of California, San Diego (UCSD); all rights reserved.
 *
 *  You may copy and distribute VERBATIM copies of this product. 
 *  You may modify your copy for your own use. You must NOT
 *  distribute modified copies. You must NOT publish benchmarking
 *  results based on modified versions.
 *
 *  If you publish any materials derived from or related to Web
 *  Polygraph, you must give a credit reference to the IRCache group.
 *
 *  Web Polygraph is distributed without any warranty, even implied.
 *
 *  Please see the COPYRIGHT file for full details.
 *
 */

#ifndef PG_POLYGRAPH_OLOG_H
#define PG_POLYGRAPH_OLOG_H

#include "AlarmClock.h"
#include "OLog.h"

// records current time and progress info when time changes
// flushes the log from time to time
// writes magic markers
class PolyOLog: public OLog, public AlarmUser {
	public:
		PolyOLog();

		void period(Time aPeriod);

		virtual void begEntry(int tag);
		virtual void wakeUp(const Alarm &alarm);

	protected:
		virtual void putHeader();
		virtual void putTrailer();

	protected:
		Time thePeriod;
		Time theModTime;
};

// one for all
extern PolyOLog TheOLog;

#endif
