
/*
 * $Id: PopModel.h,v 1.3 1999/09/07 17:47:14 rousskov Exp $
 *
 *
 * Web Polygraph                        http://polygraph.ircache.net/
 * ------------------------------------------------------------------
 *
 *  Web Polygraph is copyrighted (C) 1999 by Alex Rousskov and the
 *  University of California, San Diego (UCSD); all rights reserved.
 *
 *  You may copy and distribute VERBATIM copies of this product. 
 *  You may modify your copy for your own use. You must NOT
 *  distribute modified copies. You must NOT publish benchmarking
 *  results based on modified versions.
 *
 *  If you publish any materials derived from or related to Web
 *  Polygraph, you must give a credit reference to the IRCache group.
 *
 *  Web Polygraph is distributed without any warranty, even implied.
 *
 *  Please see the COPYRIGHT file for full details.
 *
 */

#ifndef POPULARITY_MODEL_H
#define POPULARITY_MODEL_H

class ostream;

// popularity model
class PopModel {
	public:
		PopModel() {}
		virtual ~PopModel() {}

		// any old id will do
		virtual int repeatId(int lastId) = 0;

		// try to choose one from a given selection
		// repeat any old Oid if failed
		// virtual int repeatOid(const OidSelection &sel, bool cachable) = 0;

		virtual ostream &print(ostream &os) const = 0;
};

inline
ostream &operator <<(ostream &os, const PopModel &pm) { return pm.print(os); }

#endif
