
/*
 * $Id: Progress.h,v 1.6 1999/09/07 17:47:15 rousskov Exp $
 *
 *
 * Web Polygraph                        http://polygraph.ircache.net/
 * ------------------------------------------------------------------
 *
 *  Web Polygraph is copyrighted (C) 1999 by Alex Rousskov and the
 *  University of California, San Diego (UCSD); all rights reserved.
 *
 *  You may copy and distribute VERBATIM copies of this product. 
 *  You may modify your copy for your own use. You must NOT
 *  distribute modified copies. You must NOT publish benchmarking
 *  results based on modified versions.
 *
 *  If you publish any materials derived from or related to Web
 *  Polygraph, you must give a credit reference to the IRCache group.
 *
 *  Web Polygraph is distributed without any warranty, even implied.
 *
 *  Please see the COPYRIGHT file for full details.
 *
 */

#ifndef PG_PROGRESS_CLASS_H
#define PG_PROGRESS_CLASS_H

class OLog;
class ILog;

// global progress record, updated by stat cycles
class Progress {
	public:
		Progress();

		int xacts() const { return theXactCnt; }
		int errs() const { return theErrCnt; }
		Time time() const;

		void success() { theXactCnt++; }
		void failure() { theErrCnt++; }

		void store(OLog &ol) const;
		void load(ILog &il);
		ostream &print(ostream &os) const;

	protected:
		Time theTimestamp; // place to keep Clock after load()
		int theXactCnt; // successful completions
		int theErrCnt;  // failed transactions
};

extern Progress TheProgress;

#endif
