
/*
 * $Id: StatPhaseMgr.h,v 1.4 1999/09/07 17:47:21 rousskov Exp $
 *
 *
 * Web Polygraph                        http://polygraph.ircache.net/
 * ------------------------------------------------------------------
 *
 *  Web Polygraph is copyrighted (C) 1999 by Alex Rousskov and the
 *  University of California, San Diego (UCSD); all rights reserved.
 *
 *  You may copy and distribute VERBATIM copies of this product. 
 *  You may modify your copy for your own use. You must NOT
 *  distribute modified copies. You must NOT publish benchmarking
 *  results based on modified versions.
 *
 *  If you publish any materials derived from or related to Web
 *  Polygraph, you must give a credit reference to the IRCache group.
 *
 *  Web Polygraph is distributed without any warranty, even implied.
 *
 *  Please see the COPYRIGHT file for full details.
 *
 */

#ifndef PG_STAT_PHASE_MANAGER_H
#define PG_STAT_PHASE_MANAGER_H

#include "Array.h"
#include "StatIntvl.h"

class StatPhase;

// iterates through stat phases
// flushes all sats and terminates program when the last phase is over
class StatPhaseMgr {
	public:
		StatPhaseMgr();
		~StatPhaseMgr();

		void addPhase(StatPhase *ph);
		void start();

		StatPhase *operator ->() { return thePhase; }

		void forceFlush();
		void noteDone(StatPhase *ph);

		void reportCfg(ostream &os) const;

	protected:
		void nextPhase();

	protected:
		Array <StatPhase*> thePhases; // all phases are stored here
		StatPhase *thePhase; // current phase, thePhases[thePhaseIdx]
		int thePhaseIdx;
};

#endif
