
/*
 * $Id: WorldOpts.h,v 1.6 1999/09/07 17:47:26 rousskov Exp $
 *
 *
 * Web Polygraph                        http://polygraph.ircache.net/
 * ------------------------------------------------------------------
 *
 *  Web Polygraph is copyrighted (C) 1999 by Alex Rousskov and the
 *  University of California, San Diego (UCSD); all rights reserved.
 *
 *  You may copy and distribute VERBATIM copies of this product. 
 *  You may modify your copy for your own use. You must NOT
 *  distribute modified copies. You must NOT publish benchmarking
 *  results based on modified versions.
 *
 *  If you publish any materials derived from or related to Web
 *  Polygraph, you must give a credit reference to the IRCache group.
 *
 *  Web Polygraph is distributed without any warranty, even implied.
 *
 *  Please see the COPYRIGHT file for full details.
 *
 */

#ifndef WORLD_OPTS
#define WORLD_OPTS

#include "opts.h"

class PopModel;

// popularity model option
class PopMdlOpt: public Opt {
	public:
		PopMdlOpt(OptGrp *aGrp, const char *aName, const char *aDescr, PopModel *def);

		operator void *() const { return theVal ? (void*)-1 : 0; }

		PopModel *model() { return theVal; }

		virtual bool parse(const char *name, const char *val);
		virtual void report(ostream &os) const;

	public:
		PopModel *theVal;
};

// world configuration options
class WorldOpts: public OptGrp {
	public:
		WorldOpts(); // defaults

		virtual bool validate() const;

	public:
		StrOpt theType;
		StrOpt theId;
		StrOpt theUrlsFileName;

		IntOpt theUniqStart;
		IntOpt theReqOrder;

		DblOpt theHitRatio;
		PopMdlOpt thePopMdl;

		DistrOpt theTmlDistr;
		IntOpt theTmlDelta;
		IntOpt theTmlDepth;

		IntOpt theExpOidCnt;
		IntOpt thePrefilledCnt;
};

#endif
