
/*
 * $Id: Xaction.h,v 1.22 1999/09/07 17:47:27 rousskov Exp $
 *
 *
 * Web Polygraph                        http://polygraph.ircache.net/
 * ------------------------------------------------------------------
 *
 *  Web Polygraph is copyrighted (C) 1999 by Alex Rousskov and the
 *  University of California, San Diego (UCSD); all rights reserved.
 *
 *  You may copy and distribute VERBATIM copies of this product. 
 *  You may modify your copy for your own use. You must NOT
 *  distribute modified copies. You must NOT publish benchmarking
 *  results based on modified versions.
 *
 *  If you publish any materials derived from or related to Web
 *  Polygraph, you must give a credit reference to the IRCache group.
 *
 *  Web Polygraph is distributed without any warranty, even implied.
 *
 *  Please see the COPYRIGHT file for full details.
 *
 */

#ifndef XACTION_CLASS_H
#define XACTION_CLASS_H

#include "Select.h"
#include "UniqId.h"
#include "Oid.h"

class Connection;

class Xaction: public Select::User {
	public:
		Xaction() { reset(); }

		void reset();

		const UniqId &id() const { return theId; }
		Connection *conn() { return theConn; }

		Size repSize() const { return theRepSize; }
		Time lifeTime() const { return theLifeTime; }
		const OidRec &oidRec() const { return theOidRec; }

	protected:
		void start(Connection *conn);
		void stop(int errNo);
		void stopStats();

	protected:
		Connection *theConn;
		UniqId theId;

		Time theStartTime;
		Time theLifeTime;   // [start, stop]; set in stop()
		OidRec theOidRec;   // various details about the transfered object
		Size theRepSize;    // reply size

		enum { stNone = 0, stSpaceWaiting, stHdrWaiting, stBodyWaiting, stDone } theState;
};

#endif
