
/*
 * $Id: ZipfPopMdl.h,v 1.3 1999/09/07 17:47:27 rousskov Exp $
 *
 *
 * Web Polygraph                        http://polygraph.ircache.net/
 * ------------------------------------------------------------------
 *
 *  Web Polygraph is copyrighted (C) 1999 by Alex Rousskov and the
 *  University of California, San Diego (UCSD); all rights reserved.
 *
 *  You may copy and distribute VERBATIM copies of this product. 
 *  You may modify your copy for your own use. You must NOT
 *  distribute modified copies. You must NOT publish benchmarking
 *  results based on modified versions.
 *
 *  If you publish any materials derived from or related to Web
 *  Polygraph, you must give a credit reference to the IRCache group.
 *
 *  Web Polygraph is distributed without any warranty, even implied.
 *
 *  Please see the COPYRIGHT file for full details.
 *
 */

#ifndef ZIPF_POPULARITY_MODEL_H
#define ZIPF_POPULARITY_MODEL_H

#include "PopModel.h"

class ZipfDistr;

// popularity model based around classic Zipf's law
class ZipfPopMdl: public PopModel {
	public:
		ZipfPopMdl();
		virtual ~ZipfPopMdl();

		virtual int repeatId(int lastId);
		//virtual int repeatOid(const OidSelection &sel, bool cachable);

		virtual ostream &print(ostream &os) const;

	protected:
		ZipfDistr *theDistr;
};

#endif
