
/*
 * $Id: polyErrors.cc,v 1.8 1999/09/07 17:46:42 rousskov Exp $
 *
 *
 * Web Polygraph                        http://polygraph.ircache.net/
 * ------------------------------------------------------------------
 *
 *  Web Polygraph is copyrighted (C) 1999 by Alex Rousskov and the
 *  University of California, San Diego (UCSD); all rights reserved.
 *
 *  You may copy and distribute VERBATIM copies of this product. 
 *  You may modify your copy for your own use. You must NOT
 *  distribute modified copies. You must NOT publish benchmarking
 *  results based on modified versions.
 *
 *  If you publish any materials derived from or related to Web
 *  Polygraph, you must give a credit reference to the IRCache group.
 *
 *  Web Polygraph is distributed without any warranty, even implied.
 *
 *  Please see the COPYRIGHT file for full details.
 *
 */

#include "polygraph.h"

#include "String.h"
#include "ErrorStrTbl.h"
#include "polyErrors.h"

struct PolyErrorStrTbl: public ErrorStrTbl {
	PolyErrorStrTbl();
};

PolyErrorStrTbl ThePolyErrorStrTbl;

PolyErrorStrTbl::PolyErrorStrTbl() {
	str(errForeignReq)   = "foreign request";
	str(errForeignRep)   = "foreign reply";
	str(errPrematureEof) = "premature end of msg body";
	str(errPrematureEoh) = "premature end of msg header";
	str(errExtraRepData) = "extra reply data";
	str(errNoUseClose)   = "server closed conn w/o sending data";
	str(errNoCLen)       = "no Content-Length header";
	str(errHugeHdr)      = "HTTP header is too big";
	str(errUnchbHit)     = "hit on uncachable object";
	str(err1UseHit)      = "hit on first request to an object";
	str(errZeroFDLimit)  = "zero filedescriptor limit?!";
	str(errChbChange)    = "cachability status changed";
	str(errFalseHit)     = "false hit";
	str(errServerGone)   = "server had to terminate";
	str(errLogBufFull)   = "log buffer is full";

	str(errOther) = "unclassified error";

	// check that all are defined
	for (int i = errStart+1; i < errEnd; ++i)
		Assert(item(i) && *item(i));
}

const ErrorStrTbl *polyErrorStrTbl() {
	return &ThePolyErrorStrTbl;	
}
