
/*
 * $Id: LexToken.cc,v 1.3 1999/09/07 17:48:16 rousskov Exp $
 *
 *
 * Web Polygraph                        http://polygraph.ircache.net/
 * ------------------------------------------------------------------
 *
 *  Web Polygraph is copyrighted (C) 1999 by Alex Rousskov and the
 *  University of California, San Diego (UCSD); all rights reserved.
 *
 *  You may copy and distribute VERBATIM copies of this product. 
 *  You may modify your copy for your own use. You must NOT
 *  distribute modified copies. You must NOT publish benchmarking
 *  results based on modified versions.
 *
 *  If you publish any materials derived from or related to Web
 *  Polygraph, you must give a credit reference to the IRCache group.
 *
 *  Web Polygraph is distributed without any warranty, even implied.
 *
 *  Please see the COPYRIGHT file for full details.
 *
 */

#include "xparser.h"

#include "LexToken.h"


/* LexTokenChar */

LexTokenChar::LexTokenChar(): ch(0), isFirstOnLine(false) {
}


/* LexToken */

void LexToken::reset() {
	theId = -1;
	theSpell = 0;
	isFirstOnLine = false;
}

void LexToken::addChar(char c) {
	if (theSpell.len() < 4096)
		theSpell += c;
	else
		cerr << theLoc << "input token is already " << theSpell.len() << " characters long" << endl << xexit;
}

LexToken &LexToken::operator +=(const LexTokenChar &c) {
	addChar(c.ch);
	isFirstOnLine = c.isFirstOnLine;
	return *this;
}

void LexToken::trim(char c) {
	// ltrim
	int i = 0;
	while (i < theSpell.len() && theSpell[i] == c) ++i;

	// rtrim
	int j = theSpell.len() - 1;
	while (j > 0 && theSpell[j-1] == c) --j;
	theSpell = theSpell(i, j);
}
